#define SNAPLEN 2312
#define PROMISC 1
#define TIMEOUT 500

#define QOSHDROFFSET 24
#define TKIPHDROFFSET 24+2

#define DOT11_TYPE_DATA 2
#define DOT11_SUBTYPE_QOS 8


struct dot11hdr {
	union {
		struct {
			uint8_t		version:2;
			uint8_t		type:2;
			uint8_t		subtype:4;
			uint8_t		to_ds:1;
			uint8_t		from_ds:1;
			uint8_t		more_frag:1;
			uint8_t		retry:1;
			uint8_t		pwrmgmt:1;
			uint8_t		more_data:1;
			uint8_t		wep:1;
			uint8_t		order:1;
		} __attribute__ ((packed)) fc;

		uint16_t	fchdr;
	} u1;

	uint16_t	duration;
	uint8_t		addr1[6];
	uint8_t		addr2[6];
	uint8_t		addr3[6];

	union {
		struct {
			uint16_t	fragment:4;
			uint16_t	sequence:12;
		} __attribute__ ((packed)) seq;

		uint16_t	seqhdr;
	} u2;

} __attribute__ ((packed));


struct wmmhdr {
	uint8_t		priority:3;
	uint8_t		reserved3:1;
	uint8_t		eosp:1;
	uint8_t		ackpol:2;
	uint8_t		reserved1:1;
	uint8_t		reserved2;
} __attribute__ ((packed));


struct tkiphdr {
	union {
		struct {
			uint8_t		tsc1;
			uint8_t		wepseed;
			uint8_t		tsc0;
			uint8_t		reserved1:5;
			uint8_t		extiv:1;
			uint8_t		keyid:2;
		} __attribute ((packed)) iv;

		uint8_t		ivhdr;
	} u1;

	union {
		struct {
			uint8_t		tsc2;
			uint8_t		tsc3;
			uint8_t		tsc4;
			uint8_t		tsc5;
		} extiv;

		uint8_t		extivhdr;
	} u2;
	
} __attribute__ ((packed));
